/*
 * $Id: syscall_hijack_autogen.c,v 1.18 2001/12/01 14:46:49 chooga Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include <linux/types.h>
#include <linux/time.h>


/*
 * Stub functions for syscall hijacking.
 */

/* stub function for syscall 'open' (5). */
asmlinkage static int
stub_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*stub_func_5)(const char* pathname, int flags, mode_t mode);
	stub_func_5 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[5]);
	if (rc < 0)
		return rc;
	syscall_ref_count[5]++;
	up(&syscall_sem[5]);
	func = (stub_func_5)hijacking_functions[5];

	retval = (func ? (*func)(pathname, flags, mode) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[5]);
	if (rc < 0)
		return rc;
	syscall_ref_count[5]--;
	up(&syscall_sem[5]);

	return retval;
}

/* stub function for syscall 'link' (9). */
asmlinkage static int
stub_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_9)(const char* oldpath, const char* newpath);
	stub_func_9 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[9]);
	if (rc < 0)
		return rc;
	syscall_ref_count[9]++;
	up(&syscall_sem[9]);
	func = (stub_func_9)hijacking_functions[9];

	retval = (func ? (*func)(oldpath, newpath) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[9]);
	if (rc < 0)
		return rc;
	syscall_ref_count[9]--;
	up(&syscall_sem[9]);

	return retval;
}

/* stub function for syscall 'unlink' (10). */
asmlinkage static int
stub_syscall_10(const char* pathname) {
	typedef int
		(*stub_func_10)(const char* pathname);
	stub_func_10 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[10]);
	if (rc < 0)
		return rc;
	syscall_ref_count[10]++;
	up(&syscall_sem[10]);
	func = (stub_func_10)hijacking_functions[10];

	retval = (func ? (*func)(pathname) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[10]);
	if (rc < 0)
		return rc;
	syscall_ref_count[10]--;
	up(&syscall_sem[10]);

	return retval;
}

/* stub function for syscall 'chdir' (12). */
asmlinkage static int
stub_syscall_12(const char* pathname) {
	typedef int
		(*stub_func_12)(const char* pathname);
	stub_func_12 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[12]);
	if (rc < 0)
		return rc;
	syscall_ref_count[12]++;
	up(&syscall_sem[12]);
	func = (stub_func_12)hijacking_functions[12];

	retval = (func ? (*func)(pathname) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[12]);
	if (rc < 0)
		return rc;
	syscall_ref_count[12]--;
	up(&syscall_sem[12]);

	return retval;
}

/* stub function for syscall 'chmod' (15). */
asmlinkage static int
stub_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_15)(const char* pathname, mode_t mode);
	stub_func_15 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[15]);
	if (rc < 0)
		return rc;
	syscall_ref_count[15]++;
	up(&syscall_sem[15]);
	func = (stub_func_15)hijacking_functions[15];

	retval = (func ? (*func)(pathname, mode) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[15]);
	if (rc < 0)
		return rc;
	syscall_ref_count[15]--;
	up(&syscall_sem[15]);

	return retval;
}

/* stub function for syscall 'lseek' (19). */
asmlinkage static int
stub_syscall_19(int fildes, off_t offset, int whence) {
	typedef int
		(*stub_func_19)(int fildes, off_t offset, int whence);
	stub_func_19 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[19]);
	if (rc < 0)
		return rc;
	syscall_ref_count[19]++;
	up(&syscall_sem[19]);
	func = (stub_func_19)hijacking_functions[19];

	retval = (func ? (*func)(fildes, offset, whence) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[19]);
	if (rc < 0)
		return rc;
	syscall_ref_count[19]--;
	up(&syscall_sem[19]);

	return retval;
}

/* stub function for syscall 'getpid' (20). */
asmlinkage static int
stub_syscall_20(void) {
	typedef int
		(*stub_func_20)(void);
	stub_func_20 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[20]);
	if (rc < 0)
		return rc;
	syscall_ref_count[20]++;
	up(&syscall_sem[20]);
	func = (stub_func_20)hijacking_functions[20];

	retval = (func ? (*func)() : -ENOSYS);
	rc = down_interruptible(&syscall_sem[20]);
	if (rc < 0)
		return rc;
	syscall_ref_count[20]--;
	up(&syscall_sem[20]);

	return retval;
}

/* stub function for syscall 'access' (33). */
asmlinkage static int
stub_syscall_33(const char* pathname, int mode) {
	typedef int
		(*stub_func_33)(const char* pathname, int mode);
	stub_func_33 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[33]);
	if (rc < 0)
		return rc;
	syscall_ref_count[33]++;
	up(&syscall_sem[33]);
	func = (stub_func_33)hijacking_functions[33];

	retval = (func ? (*func)(pathname, mode) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[33]);
	if (rc < 0)
		return rc;
	syscall_ref_count[33]--;
	up(&syscall_sem[33]);

	return retval;
}

/* stub function for syscall 'nice' (34). */
asmlinkage static int
stub_syscall_34(int inc) {
	typedef int
		(*stub_func_34)(int inc);
	stub_func_34 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[34]);
	if (rc < 0)
		return rc;
	syscall_ref_count[34]++;
	up(&syscall_sem[34]);
	func = (stub_func_34)hijacking_functions[34];

	retval = (func ? (*func)(inc) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[34]);
	if (rc < 0)
		return rc;
	syscall_ref_count[34]--;
	up(&syscall_sem[34]);

	return retval;
}

/* stub function for syscall 'kill' (37). */
asmlinkage static int
stub_syscall_37(pid_t pid, int sig) {
	typedef int
		(*stub_func_37)(pid_t pid, int sig);
	stub_func_37 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[37]);
	if (rc < 0)
		return rc;
	syscall_ref_count[37]++;
	up(&syscall_sem[37]);
	func = (stub_func_37)hijacking_functions[37];

	retval = (func ? (*func)(pid, sig) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[37]);
	if (rc < 0)
		return rc;
	syscall_ref_count[37]--;
	up(&syscall_sem[37]);

	return retval;
}

/* stub function for syscall 'rename' (38). */
asmlinkage static int
stub_syscall_38(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_38)(const char* oldpath, const char* newpath);
	stub_func_38 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[38]);
	if (rc < 0)
		return rc;
	syscall_ref_count[38]++;
	up(&syscall_sem[38]);
	func = (stub_func_38)hijacking_functions[38];

	retval = (func ? (*func)(oldpath, newpath) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[38]);
	if (rc < 0)
		return rc;
	syscall_ref_count[38]--;
	up(&syscall_sem[38]);

	return retval;
}

/* stub function for syscall 'mkdir' (39). */
asmlinkage static int
stub_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_39)(const char* pathname, mode_t mode);
	stub_func_39 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[39]);
	if (rc < 0)
		return rc;
	syscall_ref_count[39]++;
	up(&syscall_sem[39]);
	func = (stub_func_39)hijacking_functions[39];

	retval = (func ? (*func)(pathname, mode) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[39]);
	if (rc < 0)
		return rc;
	syscall_ref_count[39]--;
	up(&syscall_sem[39]);

	return retval;
}

/* stub function for syscall 'rmdir' (40). */
asmlinkage static int
stub_syscall_40(const char* pathname) {
	typedef int
		(*stub_func_40)(const char* pathname);
	stub_func_40 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[40]);
	if (rc < 0)
		return rc;
	syscall_ref_count[40]++;
	up(&syscall_sem[40]);
	func = (stub_func_40)hijacking_functions[40];

	retval = (func ? (*func)(pathname) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[40]);
	if (rc < 0)
		return rc;
	syscall_ref_count[40]--;
	up(&syscall_sem[40]);

	return retval;
}

/* stub function for syscall 'dup' (41). */
asmlinkage static int
stub_syscall_41(int oldfd) {
	typedef int
		(*stub_func_41)(int oldfd);
	stub_func_41 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[41]);
	if (rc < 0)
		return rc;
	syscall_ref_count[41]++;
	up(&syscall_sem[41]);
	func = (stub_func_41)hijacking_functions[41];

	retval = (func ? (*func)(oldfd) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[41]);
	if (rc < 0)
		return rc;
	syscall_ref_count[41]--;
	up(&syscall_sem[41]);

	return retval;
}

/* stub function for syscall 'chroot' (61). */
asmlinkage static int
stub_syscall_61(const char* path) {
	typedef int
		(*stub_func_61)(const char* path);
	stub_func_61 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[61]);
	if (rc < 0)
		return rc;
	syscall_ref_count[61]++;
	up(&syscall_sem[61]);
	func = (stub_func_61)hijacking_functions[61];

	retval = (func ? (*func)(path) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[61]);
	if (rc < 0)
		return rc;
	syscall_ref_count[61]--;
	up(&syscall_sem[61]);

	return retval;
}

/* stub function for syscall 'dup2' (63). */
asmlinkage static int
stub_syscall_63(int oldfd, int newfd) {
	typedef int
		(*stub_func_63)(int oldfd, int newfd);
	stub_func_63 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[63]);
	if (rc < 0)
		return rc;
	syscall_ref_count[63]++;
	up(&syscall_sem[63]);
	func = (stub_func_63)hijacking_functions[63];

	retval = (func ? (*func)(oldfd, newfd) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[63]);
	if (rc < 0)
		return rc;
	syscall_ref_count[63]--;
	up(&syscall_sem[63]);

	return retval;
}

/* stub function for syscall 'symlink' (83). */
asmlinkage static int
stub_syscall_83(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_83)(const char* oldpath, const char* newpath);
	stub_func_83 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[83]);
	if (rc < 0)
		return rc;
	syscall_ref_count[83]++;
	up(&syscall_sem[83]);
	func = (stub_func_83)hijacking_functions[83];

	retval = (func ? (*func)(oldpath, newpath) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[83]);
	if (rc < 0)
		return rc;
	syscall_ref_count[83]--;
	up(&syscall_sem[83]);

	return retval;
}

/* stub function for syscall 'settimeofday' (79). */
asmlinkage static int
stub_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int
		(*stub_func_79)(const struct timeval* tv, struct timezone* tz);
	stub_func_79 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[79]);
	if (rc < 0)
		return rc;
	syscall_ref_count[79]++;
	up(&syscall_sem[79]);
	func = (stub_func_79)hijacking_functions[79];

	retval = (func ? (*func)(tv, tz) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[79]);
	if (rc < 0)
		return rc;
	syscall_ref_count[79]--;
	up(&syscall_sem[79]);

	return retval;
}

/* stub function for syscall 'getpriority' (96). */
asmlinkage static int
stub_syscall_96(int which, int who) {
	typedef int
		(*stub_func_96)(int which, int who);
	stub_func_96 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[96]);
	if (rc < 0)
		return rc;
	syscall_ref_count[96]++;
	up(&syscall_sem[96]);
	func = (stub_func_96)hijacking_functions[96];

	retval = (func ? (*func)(which, who) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[96]);
	if (rc < 0)
		return rc;
	syscall_ref_count[96]--;
	up(&syscall_sem[96]);

	return retval;
}

/* stub function for syscall 'setpriority' (97). */
asmlinkage static int
stub_syscall_97(int which, int who, int pro) {
	typedef int
		(*stub_func_97)(int which, int who, int pro);
	stub_func_97 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[97]);
	if (rc < 0)
		return rc;
	syscall_ref_count[97]++;
	up(&syscall_sem[97]);
	func = (stub_func_97)hijacking_functions[97];

	retval = (func ? (*func)(which, who, pro) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[97]);
	if (rc < 0)
		return rc;
	syscall_ref_count[97]--;
	up(&syscall_sem[97]);

	return retval;
}

/* stub function for syscall 'setuid' (213). */
asmlinkage static int
stub_syscall_213(uid_t uid) {
	typedef int
		(*stub_func_213)(uid_t uid);
	stub_func_213 func;
	int retval;
	int rc;
	rc = down_interruptible(&syscall_sem[213]);
	if (rc < 0)
		return rc;
	syscall_ref_count[213]++;
	up(&syscall_sem[213]);
	func = (stub_func_213)hijacking_functions[213];

	retval = (func ? (*func)(uid) : -ENOSYS);
	rc = down_interruptible(&syscall_sem[213]);
	if (rc < 0)
		return rc;
	syscall_ref_count[213]--;
	up(&syscall_sem[213]);

	return retval;
}


/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr stub_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_9,
	(func_ptr)stub_syscall_10,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_19,
	(func_ptr)stub_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_33,
	(func_ptr)stub_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_37,
	(func_ptr)stub_syscall_38,
	(func_ptr)stub_syscall_39,
	(func_ptr)stub_syscall_40,
	(func_ptr)stub_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_61,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_96,
	(func_ptr)stub_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
