/*
 * $Id: syscall_tracker_autogen.c,v 1.18 2001/12/01 14:46:49 chooga Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

/*
 * struct-offsets evaluation functions for dynamic type-casting.
 */

/* calculate offsets of fields for struct 'timeval'. */
static long*
make_struct_offsets_vec_timeval(long* num_fields)
{
	struct timeval s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.tv_sec) - base);
		offsets_vec[1] = (long)( ((char*)&s.tv_usec) - base);

	}

	*num_fields = 2;

	return offsets_vec;
}

/* calculate offsets of fields for struct 'timezone'. */
static long*
make_struct_offsets_vec_timezone(long* num_fields)
{
	struct timezone s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.tz_minuteswest) - base);
		offsets_vec[1] = (long)( ((char*)&s.tz_dsttime) - base);

	}

	*num_fields = 2;

	return offsets_vec;
}

/* calculate offsets of fields for struct 'sockaddr'. */
static long*
make_struct_offsets_vec_sockaddr(long* num_fields)
{
	struct sockaddr s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.sa_family) - base);
		offsets_vec[1] = -1;

	}

	*num_fields = 2;

	return offsets_vec;
}

/*
 * Tracking functions for syscall hijacking.
 */

/* tracking function for syscall 'open' (5). */
asmlinkage static int
track_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*track_func_5)(const char* pathname, int flags, mode_t mode);
	track_func_5 func = (track_func_5)orig_syscalls[5];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_5_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_int_val(flags);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_5_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[5], 5, &rule_id);
		if (action) {
			tracker_perform_action(rules[5],
			action, rule_id, 5, "open",
			"s i uh" , kern_pathname, flags, mode);
		}
		up(&tracker_sem);
	}

  tracker_5_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, flags, mode) : -ENOSYS);
}

/* tracking function for syscall 'link' (9). */
asmlinkage static int
track_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*track_func_9)(const char* oldpath, const char* newpath);
	track_func_9 func = (track_func_9)orig_syscalls[9];
	char* kern_oldpath = NULL;
	char* kern_newpath = NULL;
	long retval;

	retval = getstring(oldpath, &kern_oldpath);
	if (retval < 0) {
		kern_oldpath = NULL;
		goto tracker_9_failed_getstring;
	}
	retval = getstring(newpath, &kern_newpath);
	if (retval < 0) {
		kern_newpath = NULL;
		goto tracker_9_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_oldpath);
		filter_node_t* param1 = make_string_val(kern_newpath);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_9_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[9], 9, &rule_id);
		if (action) {
			tracker_perform_action(rules[9],
			action, rule_id, 9, "link",
			"s s" , kern_oldpath, kern_newpath);
		}
		up(&tracker_sem);
	}

  tracker_9_failed_getstring:
	if (kern_oldpath)
		putstring(kern_oldpath);
	if (kern_newpath)
		putstring(kern_newpath);

	if (retval < 0)
		return retval;


	return (func ? (*func)(oldpath, newpath) : -ENOSYS);
}

/* tracking function for syscall 'unlink' (10). */
asmlinkage static int
track_syscall_10(const char* pathname) {
	typedef int
		(*track_func_10)(const char* pathname);
	track_func_10 func = (track_func_10)orig_syscalls[10];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_10_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_10_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[10], 10, &rule_id);
		if (action) {
			tracker_perform_action(rules[10],
			action, rule_id, 10, "unlink",
			"s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_10_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}

/* tracking function for syscall 'chdir' (12). */
asmlinkage static int
track_syscall_12(const char* pathname) {
	typedef int
		(*track_func_12)(const char* pathname);
	track_func_12 func = (track_func_12)orig_syscalls[12];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_12_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_12_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[12], 12, &rule_id);
		if (action) {
			tracker_perform_action(rules[12],
			action, rule_id, 12, "chdir",
			"s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_12_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}

/* tracking function for syscall 'chmod' (15). */
asmlinkage static int
track_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*track_func_15)(const char* pathname, mode_t mode);
	track_func_15 func = (track_func_15)orig_syscalls[15];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_15_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_ushort_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_15_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[15], 15, &rule_id);
		if (action) {
			tracker_perform_action(rules[15],
			action, rule_id, 15, "chmod",
			"s uh" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_15_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'lseek' (19). */
asmlinkage static int
track_syscall_19(int fildes, off_t offset, int whence) {
	typedef int
		(*track_func_19)(int fildes, off_t offset, int whence);
	track_func_19 func = (track_func_19)orig_syscalls[19];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(fildes);
		filter_node_t* param1 = make_long_val(offset);
		filter_node_t* param2 = make_int_val(whence);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(param2);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed(VT_PARAM, 2, param2);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[19], 19, &rule_id);
		if (action) {
			tracker_perform_action(rules[19],
			action, rule_id, 19, "lseek",
			"i l i" , fildes, offset, whence);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(fildes, offset, whence) : -ENOSYS);
}

/* tracking function for syscall 'getpid' (20). */
asmlinkage static int
track_syscall_20(void) {
	typedef int
		(*track_func_20)(void);
	track_func_20 func = (track_func_20)orig_syscalls[20];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[20], 20, &rule_id);
		if (action) {
			tracker_perform_action(rules[20],
			action, rule_id, 20, "getpid",
			"v" );
		}
		up(&tracker_sem);
	}


	return (func ? (*func)() : -ENOSYS);
}

/* tracking function for syscall 'access' (33). */
asmlinkage static int
track_syscall_33(const char* pathname, int mode) {
	typedef int
		(*track_func_33)(const char* pathname, int mode);
	track_func_33 func = (track_func_33)orig_syscalls[33];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_33_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_int_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_33_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[33], 33, &rule_id);
		if (action) {
			tracker_perform_action(rules[33],
			action, rule_id, 33, "access",
			"s i" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_33_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'nice' (34). */
asmlinkage static int
track_syscall_34(int inc) {
	typedef int
		(*track_func_34)(int inc);
	track_func_34 func = (track_func_34)orig_syscalls[34];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(inc);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[34], 34, &rule_id);
		if (action) {
			tracker_perform_action(rules[34],
			action, rule_id, 34, "nice",
			"i" , inc);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(inc) : -ENOSYS);
}

/* tracking function for syscall 'kill' (37). */
asmlinkage static int
track_syscall_37(pid_t pid, int sig) {
	typedef int
		(*track_func_37)(pid_t pid, int sig);
	track_func_37 func = (track_func_37)orig_syscalls[37];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(pid);
		filter_node_t* param1 = make_int_val(sig);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[37], 37, &rule_id);
		if (action) {
			tracker_perform_action(rules[37],
			action, rule_id, 37, "kill",
			"i i" , pid, sig);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(pid, sig) : -ENOSYS);
}

/* tracking function for syscall 'rename' (38). */
asmlinkage static int
track_syscall_38(const char* oldpath, const char* newpath) {
	typedef int
		(*track_func_38)(const char* oldpath, const char* newpath);
	track_func_38 func = (track_func_38)orig_syscalls[38];
	char* kern_oldpath = NULL;
	char* kern_newpath = NULL;
	long retval;

	retval = getstring(oldpath, &kern_oldpath);
	if (retval < 0) {
		kern_oldpath = NULL;
		goto tracker_38_failed_getstring;
	}
	retval = getstring(newpath, &kern_newpath);
	if (retval < 0) {
		kern_newpath = NULL;
		goto tracker_38_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_oldpath);
		filter_node_t* param1 = make_string_val(kern_newpath);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_38_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[38], 38, &rule_id);
		if (action) {
			tracker_perform_action(rules[38],
			action, rule_id, 38, "rename",
			"s s" , kern_oldpath, kern_newpath);
		}
		up(&tracker_sem);
	}

  tracker_38_failed_getstring:
	if (kern_oldpath)
		putstring(kern_oldpath);
	if (kern_newpath)
		putstring(kern_newpath);

	if (retval < 0)
		return retval;


	return (func ? (*func)(oldpath, newpath) : -ENOSYS);
}

/* tracking function for syscall 'mkdir' (39). */
asmlinkage static int
track_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*track_func_39)(const char* pathname, mode_t mode);
	track_func_39 func = (track_func_39)orig_syscalls[39];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_39_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* param1 = make_ushort_val(mode);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_39_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[39], 39, &rule_id);
		if (action) {
			tracker_perform_action(rules[39],
			action, rule_id, 39, "mkdir",
			"s uh" , kern_pathname, mode);
		}
		up(&tracker_sem);
	}

  tracker_39_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname, mode) : -ENOSYS);
}

/* tracking function for syscall 'rmdir' (40). */
asmlinkage static int
track_syscall_40(const char* pathname) {
	typedef int
		(*track_func_40)(const char* pathname);
	track_func_40 func = (track_func_40)orig_syscalls[40];
	char* kern_pathname = NULL;
	long retval;

	retval = getstring(pathname, &kern_pathname);
	if (retval < 0) {
		kern_pathname = NULL;
		goto tracker_40_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_pathname);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_40_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[40], 40, &rule_id);
		if (action) {
			tracker_perform_action(rules[40],
			action, rule_id, 40, "rmdir",
			"s" , kern_pathname);
		}
		up(&tracker_sem);
	}

  tracker_40_failed_getstring:
	if (kern_pathname)
		putstring(kern_pathname);

	if (retval < 0)
		return retval;


	return (func ? (*func)(pathname) : -ENOSYS);
}

/* tracking function for syscall 'dup' (41). */
asmlinkage static int
track_syscall_41(int oldfd) {
	typedef int
		(*track_func_41)(int oldfd);
	track_func_41 func = (track_func_41)orig_syscalls[41];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(oldfd);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[41], 41, &rule_id);
		if (action) {
			tracker_perform_action(rules[41],
			action, rule_id, 41, "dup",
			"i" , oldfd);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(oldfd) : -ENOSYS);
}

/* tracking function for syscall 'chroot' (61). */
asmlinkage static int
track_syscall_61(const char* path) {
	typedef int
		(*track_func_61)(const char* path);
	track_func_61 func = (track_func_61)orig_syscalls[61];
	char* kern_path = NULL;
	long retval;

	retval = getstring(path, &kern_path);
	if (retval < 0) {
		kern_path = NULL;
		goto tracker_61_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_path);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_61_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[61], 61, &rule_id);
		if (action) {
			tracker_perform_action(rules[61],
			action, rule_id, 61, "chroot",
			"s" , kern_path);
		}
		up(&tracker_sem);
	}

  tracker_61_failed_getstring:
	if (kern_path)
		putstring(kern_path);

	if (retval < 0)
		return retval;


	return (func ? (*func)(path) : -ENOSYS);
}

/* tracking function for syscall 'dup2' (63). */
asmlinkage static int
track_syscall_63(int oldfd, int newfd) {
	typedef int
		(*track_func_63)(int oldfd, int newfd);
	track_func_63 func = (track_func_63)orig_syscalls[63];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(oldfd);
		filter_node_t* param1 = make_int_val(newfd);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[63], 63, &rule_id);
		if (action) {
			tracker_perform_action(rules[63],
			action, rule_id, 63, "dup2",
			"i i" , oldfd, newfd);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(oldfd, newfd) : -ENOSYS);
}

/* tracking function for syscall 'symlink' (83). */
asmlinkage static int
track_syscall_83(const char* oldpath, const char* newpath) {
	typedef int
		(*track_func_83)(const char* oldpath, const char* newpath);
	track_func_83 func = (track_func_83)orig_syscalls[83];
	char* kern_oldpath = NULL;
	char* kern_newpath = NULL;
	long retval;

	retval = getstring(oldpath, &kern_oldpath);
	if (retval < 0) {
		kern_oldpath = NULL;
		goto tracker_83_failed_getstring;
	}
	retval = getstring(newpath, &kern_newpath);
	if (retval < 0) {
		kern_newpath = NULL;
		goto tracker_83_failed_getstring;
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_string_val(kern_oldpath);
		filter_node_t* param1 = make_string_val(kern_newpath);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_83_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[83], 83, &rule_id);
		if (action) {
			tracker_perform_action(rules[83],
			action, rule_id, 83, "symlink",
			"s s" , kern_oldpath, kern_newpath);
		}
		up(&tracker_sem);
	}

  tracker_83_failed_getstring:
	if (kern_oldpath)
		putstring(kern_oldpath);
	if (kern_newpath)
		putstring(kern_newpath);

	if (retval < 0)
		return retval;


	return (func ? (*func)(oldpath, newpath) : -ENOSYS);
}

/* tracking function for syscall 'settimeofday' (79). */
asmlinkage static int
track_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int
		(*track_func_79)(const struct timeval* tv, struct timezone* tz);
	track_func_79 func = (track_func_79)orig_syscalls[79];
	struct timeval kern_tv;
	struct timezone kern_tz;
	long retval;

	if (tv) {
		if (copy_from_user(&kern_tv, tv, sizeof(kern_tv))) {
			retval = -EFAULT;
			goto tracker_79_failed_getstring;
		}
	}
	if (tz) {
		if (copy_from_user(&kern_tz, tz, sizeof(kern_tz))) {
			retval = -EFAULT;
			goto tracker_79_failed_getstring;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_filter_vector(2);
		filter_node_t* param1 = make_filter_vector(2);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);
		if (tv) {
			insert_filter_node(param0, 0, make_long_val(kern_tv.tv_sec));
			insert_filter_node(param0, 1, make_long_val(kern_tv.tv_usec));
		}
		if (tz) {
			insert_filter_node(param1, 0, make_int_val(kern_tz.tz_minuteswest));
			insert_filter_node(param1, 1, make_int_val(kern_tz.tz_dsttime));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			goto tracker_79_failed_getstring;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[79], 79, &rule_id);
		if (action) {
			tracker_perform_action(rules[79],
			action, rule_id, 79, "settimeofday",
			"S{l l} S{i i}" , "timeval", tv, (tv ? kern_tv.tv_sec : 0L), (tv ? kern_tv.tv_usec : 0L), "timezone", tz, (tz ? kern_tz.tz_minuteswest : 0), (tz ? kern_tz.tz_dsttime : 0));
		}
		up(&tracker_sem);
	}

  tracker_79_failed_getstring:

	if (retval < 0)
		return retval;


	return (func ? (*func)(tv, tz) : -ENOSYS);
}

/* tracking function for syscall 'getpriority' (96). */
asmlinkage static int
track_syscall_96(int which, int who) {
	typedef int
		(*track_func_96)(int which, int who);
	track_func_96 func = (track_func_96)orig_syscalls[96];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(which);
		filter_node_t* param1 = make_int_val(who);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[96], 96, &rule_id);
		if (action) {
			tracker_perform_action(rules[96],
			action, rule_id, 96, "getpriority",
			"i i" , which, who);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(which, who) : -ENOSYS);
}

/* tracking function for syscall 'setpriority' (97). */
asmlinkage static int
track_syscall_97(int which, int who, int pro) {
	typedef int
		(*track_func_97)(int which, int who, int pro);
	track_func_97 func = (track_func_97)orig_syscalls[97];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_int_val(which);
		filter_node_t* param1 = make_int_val(who);
		filter_node_t* param2 = make_int_val(pro);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			free_filter_node(param2);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed(VT_PARAM, 2, param2);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[97], 97, &rule_id);
		if (action) {
			tracker_perform_action(rules[97],
			action, rule_id, 97, "setpriority",
			"i i i" , which, who, pro);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(which, who, pro) : -ENOSYS);
}

/* tracking function for syscall 'setuid' (213). */
asmlinkage static int
track_syscall_213(uid_t uid) {
	typedef int
		(*track_func_213)(uid_t uid);
	track_func_213 func = (track_func_213)orig_syscalls[213];
	long retval;


	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_ushort_val(uid);
		filter_node_t* proc_uid = make_long_val((long)current->uid);
		filter_node_t* proc_euid = make_long_val((long)current->euid);
		filter_node_t* proc_suid = make_long_val((long)current->suid);
		filter_node_t* proc_gid = make_long_val((long)current->gid);
		filter_node_t* proc_egid = make_long_val((long)current->egid);
		filter_node_t* proc_sgid = make_long_val((long)current->sgid);
		filter_node_t* proc_pid = make_long_val((long)current->pid);
		filter_node_t* proc_comm = make_string_val(current->comm);

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(proc_uid); 
			free_filter_node(proc_euid);
			free_filter_node(proc_suid); 
			free_filter_node(proc_gid);
			free_filter_node(proc_egid); 
			free_filter_node(proc_sgid);
			free_filter_node(proc_pid); 
			free_filter_node(proc_comm);
			return retval;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var(VT_PROC_UID, proc_uid);
		set_var(VT_PROC_EUID, proc_euid);
		set_var(VT_PROC_SUID, proc_suid);
		set_var(VT_PROC_GID, proc_gid);
		set_var(VT_PROC_EGID, proc_egid);
		set_var(VT_PROC_SGID, proc_sgid);
		set_var(VT_PROC_PID, proc_pid);
		set_var(VT_PROC_COMM, proc_comm);
		action = filter_syscall(rules[213], 213, &rule_id);
		if (action) {
			tracker_perform_action(rules[213],
			action, rule_id, 213, "setuid",
			"uh" , uid);
		}
		up(&tracker_sem);
	}


	return (func ? (*func)(uid) : -ENOSYS);
}


void
init_mux_functions(void)
{
}

/* array of struct fields offsets - to be used when extracting struct fields. */
struct struct_data struct_type_data[3];

/* initialization of structs_type_data array. */
void
init_struct_offsets(void)
{
	long num_fields;
        long* offsets_vec;
  
	offsets_vec = make_struct_offsets_vec_timeval(&num_fields);
	struct_type_data[0].offsets_vec = offsets_vec;
	struct_type_data[0].num_fields = num_fields;
	offsets_vec = make_struct_offsets_vec_sockaddr(&num_fields);
	struct_type_data[1].offsets_vec = offsets_vec;
	struct_type_data[1].num_fields = num_fields;
	offsets_vec = make_struct_offsets_vec_timezone(&num_fields);
	struct_type_data[2].offsets_vec = offsets_vec;
	struct_type_data[2].num_fields = num_fields;

}

/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr track_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_9,
	(func_ptr)track_syscall_10,
	(func_ptr)NULL,
	(func_ptr)track_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_19,
	(func_ptr)track_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_33,
	(func_ptr)track_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_37,
	(func_ptr)track_syscall_38,
	(func_ptr)track_syscall_39,
	(func_ptr)track_syscall_40,
	(func_ptr)track_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_61,
	(func_ptr)NULL,
	(func_ptr)track_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_96,
	(func_ptr)track_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
